using Autofac;
using FitConnect.Models;
using Microsoft.Extensions.Logging;

namespace FitConnect;

public static class Client {
    public static Sender GetSender(FitConnectEnvironment environment, string clientId,
        string clientSecret, ILogger? logger = null) {
        return new(environment, clientId, clientSecret, logger);
    }

    public static Subscriber GetSubscriber(FitConnectEnvironment environment,
        string clientId, string clientSecret,
        string privateKeyDecryption,
        string privateKeySigning,
        string publicKeyEncryption,
        string publicKeySignatureVerification,
        ILogger? logger = null) {
        return new Subscriber(environment, clientId, clientSecret, privateKeyDecryption,
            privateKeySigning, publicKeyEncryption, publicKeySignatureVerification, logger);
    }

#if DEBUG
    public static Sender GetSender(FitConnectEnvironment environment, string clientId,
        string clientSecret, IContainer container) {
        return new(environment, clientId, clientSecret, container);
    }

    public static Subscriber GetSubscriber(FitConnectEnvironment environment,
        string clientId, string clientSecret,
        string privateKeyDecryption,
        string privateKeySigning,
        string publicKeyEncryption,
        string publicKeySignatureVerification,
        IContainer container) {
        return new Subscriber(environment, clientId, clientSecret, privateKeyDecryption,
            privateKeySigning, publicKeyEncryption, publicKeySignatureVerification, container);
    }
#endif
}
