using FitConnect.Models;

namespace FitConnect.Interfaces.Subscriber;

public interface ISubscriberWithSubmission {
    public Submission Submission { get; }

    /// <summary>
    ///     Loads the <see cref="Attachment" />s for the given <see cref="Submission" />.
    /// </summary>
    /// <returns></returns>
    public IEnumerable<Attachment> GetAttachments();

    /// <summary>
    ///     Accept submission and delete it from the server
    /// </summary>
    public void AcceptSubmission();

    public void RejectSubmission();
    public void ForwardSubmission();
    public void CompleteSubmission(FinishSubmissionStatus status);
}
